/*
 *  Copyright (C) 2002-2003  Massachusetts Institute of Technology
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */

#ifndef NS_CFSRW_H
#define NS_CFSRW_H

#include "async.h"
#include "sfscrypt.h"
#include "ns.h"

class cfs_data;
typedef callback<void, ptr<cfs_data> >::ref nscb_cfs_t;

class ns_cfsrw
{
public:
  static void retrieve_cfs (bigint id, nscb_cfs_t cb);
  static void retrieve_cfs_readonly (bigint id, nscb_cfs_t cb);
  static void insert_cfs (const char *, size_t, nscb_insert_t cb,
                          ptr<cfs_data> s = 0);
  static void insert_cfs (bigint, const char *, size_t, nscb_insert_t cb,
                          ptr<cfs_data> s = 0);
  static bool has_cfs  (bigint);
};

#endif

