/*
 *  Copyright (C) 2002-2003  Massachusetts Institute of Technology
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */

#ifndef RANGES_H
#define RANGES_H

#include "sfsmisc.h"
#include "list.h"
#include "rxx.h"

struct range {
  uint64 _start;
  uint64 _len;
  list_entry<range> _link;

  range (uint64 s, uint64 l) { _start = s; _len = l; }
};

class ranges {
private:
  list<range, &range::_link> _l;
  uint64 _size;

public:
  ranges (uint64 size = 0xffffffffffffffffULL);
  ~ranges ();
  void add (uint64, uint64);
  bool check (uint64, uint64);
  uint64 end ();
  bool gaps (callback<void, uint64, uint64>::ref cb);
  bool filled(uint64, uint64) const;
  bool has_next_gap(uint64, uint64&, uint64&) const;
};

#endif // __RANGES_H
