/*
 * Write 2 bytes -- "xy".
 * Truncate to 1 byte long.
 * "Truncate" to 3 bytes long.
 * Result must be "x\0\0", not "xy\0".
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void check_ret(int ok, char *msg);
extern int errno;
char fname[256];

main()
{
  char buf[512];
  int fd, cc;

  sprintf(fname, "xwttr-%d", getpid());

  fd = creat(fname, 0666);
  check_ret(fd >= 0, "creat");
  check_ret(write(fd, "xy", 2) == 2, "write");
  check_ret(ftruncate(fd, 1) == 0, "ftruncate");
  check_ret(ftruncate(fd, 3) == 0, "second ftruncate");
  check_ret(close(fd) == 0, "close");

  fd = open(fname, 0);
  check_ret(fd >= 0, "open");
  buf[0] = buf[1] = buf[2] = 'z';
  cc = read(fd, buf, sizeof(buf));
  close(fd);
  unlink(fname);
  
  if(cc != 3){
    fprintf(stderr, "wttr: expected %d bytes, wanted 3\n", cc);
    exit(1);
  }

  if(buf[0] != 'x' || buf[1] != '\0' || buf[2] != '\0'){
    fprintf(stderr, "wttr: bad contents %02x %02x %02x\n",
            buf[0], buf[1], buf[2]);
    exit(1);
  }

  exit(0);
}

void
check_ret(int ok, char *msg)
{
  if(ok == 0){
    fprintf(stderr, "mtime failure: %s: %s\n", msg, strerror(errno));
    unlink(fname);
    exit(1);
  }
}
